-- name: [CS] Sonks himself
-- description: My Oc. thanks for Mr Maxi for helping me doing the model!

if not _G.charSelectExists then
    djui_popup_create("\\#ffffa0\\Sonks requires\nCharacter Select to be enabled.\n\nPlease rehost with it enabled.", 4)
    return
end

-- Characters are stored in a table for ease of addition

Sonks = {
    -----------
    -- Sonks --
    -----------
    {
        name = "Sonks",
        description = "the guy who no one knows. and he for some reason comunicates whit NSMBDS SFX",
        credits = "Sonkz_132 / Mr Maxi",
        color = { r = 80, g = 0, b = 0 },
        model = smlua_model_util_get_id("sonks_geo"),
        forceChar = CT_MARIO,
        lifeIcon = get_texture_info("icon-sonks"),
        camScale = 0.8,
        offset = 0,
        voices = {
            [CHAR_SOUND_ATTACKED] = "hit_block.ogg",
            [CHAR_SOUND_DOH] = "swim.ogg",
            [CHAR_SOUND_DROWNING] = "1down.ogg",
            [CHAR_SOUND_DYING] = "1down.ogg",
            [CHAR_SOUND_GROUND_POUND_WAH] = "start_ground_pound.ogg",
            [CHAR_SOUND_HAHA] = "save_powerup.ogg",
            [CHAR_SOUND_HAHA_2] = "save_powerup.ogg",
            [CHAR_SOUND_HERE_WE_GO] = "1up.ogg",
            [CHAR_SOUND_HOOHOO] = "spring.ogg",
            [CHAR_SOUND_LETS_A_GO] = "1up.ogg",
            [CHAR_SOUND_OOOF] = "hit_block.ogg",
            [CHAR_SOUND_OOOF2] = "hit_block.ogg",
            [CHAR_SOUND_PUNCH_HOO] = "kick.ogg",
            [CHAR_SOUND_PUNCH_WAH] = "break_block.ogg",
            [CHAR_SOUND_PUNCH_YAH] = "break_block.ogg",
            [CHAR_SOUND_SO_LONGA_BOWSER] = "groundpound_land.ogg",
            [CHAR_SOUND_TWIRL_BOUNCE] = "coin_get.ogg",
            [CHAR_SOUND_WAH2] = "nsmb_jump.ogg",
            [CHAR_SOUND_YAHOO] = "coin_get.ogg",
            [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = "coin_get.ogg",
            [CHAR_SOUND_YAH_WAH_HOO] = "nsmb_jump.ogg",
        },
        anims = nil
    },
}

local CSloaded = false
local function on_character_select_load()
    for i = 1, #Sonks do
        local char = Sonks[i]
        char.tablePos = _G.charSelect.character_add(char.name, char.description, char.credits, char.color, char.model, char.forceChar, char.lifeIcon, char.camScale, char.offset)
        if char.caps then _G.charSelect.character_add_caps(char.model, char.caps) end
        if char.voices then _G.charSelect.character_add_voice(char.model, char.voices) end
        if char.palette then _G.charSelect.character_add_palette_preset(char.model, char.palette) end
        if char.anims then _G.charSelect.character_add_animations(char.model, char.anims) end
    end

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    for i = 1, #Sonks do
        if _G.charSelect.character_get_voice(m) == Sonks[i].voices then return _G.charSelect.voice.sound(m, sound) end
    end
end

local function on_character_snore(m)
    if not CSloaded then return end
    for i = 1, #Sonks do
        if _G.charSelect.character_get_voice(m) == Sonks[i].voices then return _G.charSelect.voice.snore(m) end
    end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)